'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _pullAt2 = require('lodash/pullAt');

var _pullAt3 = _interopRequireDefault(_pullAt2);

var _concat2 = require('lodash/concat');

var _concat3 = _interopRequireDefault(_concat2);

var _startsWith2 = require('lodash/startsWith');

var _startsWith3 = _interopRequireDefault(_startsWith2);

var _some2 = require('lodash/some');

var _some3 = _interopRequireDefault(_some2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FormField2 = require('./FormField');

var _FormField3 = _interopRequireDefault(_FormField2);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _events = require('../utils/events');

var _events2 = _interopRequireDefault(_events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Autocomplete = (_temp2 = _class = function (_FormField) {
  _inherits(Autocomplete, _FormField);

  function Autocomplete() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Autocomplete);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Autocomplete.__proto__ || Object.getPrototypeOf(Autocomplete)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      selectedWords: [],
      filteredWords: _this.props.sortAlphabetically && _this.props.suggestedWords ? _this.props.suggestedWords.sort() : _this.props.suggestedWords || [],
      isSuggestionsOpened: false,
      highlightedOptionIndex: 0,
      dropdownParams: null
    }, _this.focus = function () {
      return _this.handleAutocompleteClick();
    }, _this.openSuggestions = function () {
      var root = _this._getRootSkinPart();
      var rootElementParams = root.getBoundingClientRect();

      var dropdownParams = {
        width: rootElementParams.width,
        positionX: rootElementParams.left,
        positionY: rootElementParams.y + rootElementParams.height + 20
      };

      _this.setState({ isSuggestionsOpened: true, highlightedOptionIndex: 0, dropdownParams: dropdownParams });
    }, _this.closeSuggestions = function () {
      _this.setState({ isSuggestionsOpened: false, highlightedOptionIndex: 0, dropdownParams: null });
    }, _this.handleAutocompleteClick = function () {
      _this._getInputSkinPart().focus();
      if (!_this.state.isSuggestionsOpened) {
        _this.openSuggestions();
      } else {
        _this.closeSuggestions();
      }
    }, _this._handleDocumentClick = function (event) {
      var root = _this._getRootSkinPart();
      var isDescendant = _events2.default.targetIsDescendant(event, _reactDom2.default.findDOMNode(root));
      if (_this.state.isSuggestionsOpened && !isDescendant) {
        _this.closeSuggestions();
      }
    }, _this.onKeyDown = function (event) {
      var selectedWords = _this.state.selectedWords;


      switch (event.keyCode) {
        case 8:
          // Delte on backspace
          if (!event.target.value && selectedWords.length) {
            _this.removeWord(selectedWords.length - 1, event); // remove last
          }
          break;
        case 9:
          // Select currently highlighted option on 'Tab' key
          event.preventDefault();
          _this.updateSelectedWords(event);
          break;
        case 13:
          // Select currently highlighted option on 'Enter' key
          _this.updateSelectedWords(event);
          break;
        case 27:
          // Close on 'Escape' key
          _this.closeSuggestions();
          break;
        case 38:
          // Move selection higlight 'up' on Arrow Up key
          _this._handleHighlightMove(event, 'up');
          break;
        case 40:
          // Move selection higlight 'down' on Arrow Down key
          _this._handleHighlightMove(event, 'down');
          break;
        default:
          _this.openSuggestions();
      }
    }, _this._handleHighlightMove = function (event, direction) {
      event.preventDefault();

      var maxVisibleSuggestions = _this.props.maxVisibleSuggestions;
      var _this$state = _this.state,
          filteredWords = _this$state.filteredWords,
          highlightedOptionIndex = _this$state.highlightedOptionIndex;


      var position = void 0;
      if (direction === 'up') {
        position = highlightedOptionIndex - 1;
      } else if (direction === 'down') {
        position = highlightedOptionIndex + 1;
      }

      var maxPosition = maxVisibleSuggestions < filteredWords.length ? maxVisibleSuggestions : filteredWords.length;

      if (position >= 0 && position < maxPosition) {
        _this.setState({ highlightedOptionIndex: position, isSuggestionsOpened: true });
      }
    }, _this.setHighlightedOptionIndex = function (index) {
      _this.setState({ highlightedOptionIndex: index });
    }, _this.clearInvalidChars = function (event) {
      var value = event.target.value;

      if (_this.props.invalidCharsRegex.test(value)) {
        event.target.value = value.replace(_this.props.invalidCharsRegex, '');
        return;
      }

      var filteredWords = [];
      (0, _some3.default)(_this.props.suggestedWords, function (suggestedWord) {
        if ((0, _startsWith3.default)(suggestedWord, value)) {
          filteredWords.push(suggestedWord);
        }
      });

      _this.setState({ filteredWords: value !== '' ? filteredWords : _this.props.suggestedWords });
    }, _this.updateSelectedWords = function (event) {
      var canMoreWordsBeSelected = _this.state.selectedWords.length < _this.props.maxSelections;
      var areFilteredWordsAvailable = _this.state.filteredWords && _this.state.filteredWords.length > 0;

      if (!_this.props.maxSelections || canMoreWordsBeSelected && areFilteredWordsAvailable) {
        var value = _this.state.filteredWords[_this.state.highlightedOptionIndex];

        if (!value) {
          return;
        }

        var word = value.trim();
        var wordCanBeSelected = _this.state.selectedWords.indexOf(word) < 0 && !_this.props.multipleSameSelections || _this.props.multipleSameSelections;

        if (word && wordCanBeSelected && _this.state.isSuggestionsOpened) {
          var selectedWords = (0, _concat3.default)(_this.state.selectedWords, word);

          _this.selectionChanged(selectedWords, event);
          _this.setState({
            selectedWords: selectedWords,
            highlightedOptionIndex: 0,
            isSuggestionsOpened: false
          });
        }
      }

      var input = _this._getInputSkinPart();
      input.value = '';
    }, _this.removeWord = function (index, event) {
      var selectedWords = _this.state.selectedWords;
      (0, _pullAt3.default)(selectedWords, index);
      _this.selectionChanged(selectedWords, event);
      _this.setState({ selectedWords: selectedWords });
    }, _this.selectionChanged = function (selectedWords, event) {
      if (_this.props.onChange) _this.props.onChange(selectedWords, event);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Autocomplete, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var node = this._getRootSkinPart();
      var parentNode = node.parentNode;

      _events2.default.addEventsToDocument(this._getDocumentEvents());
      window.addEventListener('resize', this.closeSuggestions);

      // handle scroll e.g in modal - by default scroll handler is only on document
      parentNode.addEventListener('scroll', this.closeSuggestions);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var node = this._getRootSkinPart();
      var parentNode = node.parentNode;

      _events2.default.removeEventsFromDocument(this._getDocumentEvents());
      window.removeEventListener('resize', this.closeSuggestions);
      parentNode.removeEventListener('scroll', this.closeSuggestions);
    }
  }, {
    key: 'prepareSkinProps',
    value: function prepareSkinProps(props) {
      return Object.assign({}, _get(Autocomplete.prototype.__proto__ || Object.getPrototypeOf(Autocomplete.prototype), 'prepareSkinProps', this).call(this, props), {
        selectedWords: this.state.selectedWords,
        filteredWords: this.state.filteredWords,
        isSuggestionsOpened: this.state.isSuggestionsOpened,
        highlightedOptionIndex: this.state.highlightedOptionIndex,
        maxSelections: this.props.maxSelections,
        maxVisibleSuggestions: this.props.maxVisibleSuggestions,
        dropdownParams: this.state.dropdownParams
      });
    }

    // onKeyUp handler

  }, {
    key: '_getRootSkinPart',
    value: function _getRootSkinPart() {
      return this.skinParts[Autocomplete.SKIN_PARTS.ROOT];
    }
  }, {
    key: '_getInputSkinPart',
    value: function _getInputSkinPart() {
      return this.skinParts[Autocomplete.SKIN_PARTS.INPUT];
    }
  }, {
    key: '_getDocumentEvents',
    value: function _getDocumentEvents() {
      return {
        click: this._handleDocumentClick,
        scroll: this.closeSuggestions
      };
    }
  }]);

  return Autocomplete;
}(_FormField3.default), _class.SKIN_PARTS = {
  ROOT: 'root',
  INPUT: 'input',
  SUGGESTIONS: 'suggestions'
}, _class.propTypes = Object.assign({}, _FormField3.default.propTypes, {
  error: _propTypes2.default.string,
  maxSelections: _propTypes2.default.number,
  placeholder: _propTypes2.default.string,
  suggestedWords: _propTypes2.default.array,
  sortAlphabetically: _propTypes2.default.bool,
  multipleSameSelections: _propTypes2.default.bool,
  maxVisibleSuggestions: _propTypes2.default.number,
  invalidCharsRegex: _propTypes2.default.instanceOf(RegExp)
}), _class.defaultProps = {
  maxVisibleSuggestions: 10, // max number of visible suggested words
  multipleSameSelections: true, // if true then same word can be selected multiple times
  sortAlphabetically: true, // suggested words are sorted alphabetically by default
  invalidCharsRegex: /[^a-zA-Z0-9]/g // only allow letters and numbers by default
}, _temp2);
exports.default = Autocomplete;
//# sourceMappingURL=Autocomplete.js.map